package dev.shadowsoffire.apotheosis.spawn.modifiers;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.spawn.modifiers.StatModifier;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;

public interface SpawnerStat<T> {
  String getId();
  
  Codec<StatModifier<T>> getModifierCodec();
  
  T getValue(ApothSpawnerTile paramApothSpawnerTile);
  
  Component getTooltip(ApothSpawnerTile paramApothSpawnerTile);
  
  boolean apply(T paramT1, T paramT2, T paramT3, ApothSpawnerTile paramApothSpawnerTile);
  
  default MutableComponent name() {
    return Component.m_237115_("stat.apotheosis." + getId());
  }
  
  default MutableComponent desc() {
    return Component.m_237115_("stat.apotheosis." + getId() + ".desc");
  }
}
